open ExtLib
open Commons

let create n = Hashtbl.create (n/256)
let set m id v = 
	let key = id land 0x7FFFFF00 in
	try
		let a = Hashtbl.find m key in a.[id land 0xFF] <- char_of_int (v+1) 
	with Not_found -> 
		let a = String.make 256 (char_of_int 0) in
		a.[id land 0xFF] <- char_of_int (v+1);
		Hashtbl.add m key a;;	
	
let get m id = 
	let key = id land 0x7FFFFF00 in
	try 
		let a = Hashtbl.find m key in 
		let v = int_of_char a.[id land 0xFF] in
		if v<>0 then v-1 else raise Postpone	
	with Not_found -> raise Postpone;;